import 'package:chopper/chopper.dart';
import 'dart:async';

class AdeptChopperClient extends ChopperClient {
  Duration? timeout;

  AdeptChopperClient({
    super.baseUrl,
    super.client,
    super.interceptors,
    super.authenticator,
    super.converter,
    super.errorConverter,
    super.services,
    this.timeout,
  });

  @override
  Future<Response<Body>> send<Body, ToDecode>(
    Request request, {
    ConvertRequest? requestConverter,
    ConvertResponse? responseConverter,
  }) async {
    final Future<Response<Body>> response = super.send(request,
        requestConverter: requestConverter,
        responseConverter: responseConverter);
    return timeout != null ? response.timeout(timeout!) : response;
  }
}
