import 'package:adeptarch_base/src/filters/filter.dart';
import 'package:json_annotation/json_annotation.dart';

part 'text_filter.g.dart';

@JsonSerializable()
class TextFilter extends Filter<TextFilter, String> {
  TextFilter({
    required String? param,
    SortMode? sortMode,
    FilterActionType? filterActionType,
  }) : super(
          param: param,
          sortMode: sortMode,
          filterActionType: filterActionType,
        );

  TextFilter contains(String value) => action(value, FilterActions.CONTAINS);

  @override
  Map<String, dynamic> toJson() => _$TextFilterToJson(this);
  @override
  TextFilter? fromJsonMap(Map<String, dynamic>? json) =>
      json != null ? TextFilter.fromJson(json) : null;
  factory TextFilter.fromJson(Map<String, dynamic> json) =>
      _$TextFilterFromJson(json);
}
