import 'package:adeptutils/adeptutils.dart';
import 'package:rxdart/rxdart.dart';
import 'dart:async';

class AdeptPublishSubject<T> {
  dynamic id;
  AdeptController? valueNotifier;
  final PublishSubject<T?> publishSubject;
  T? _value;
  T? get value => _value;

  AdeptPublishSubject({this.id, this.valueNotifier})
      : publishSubject = PublishSubject<T>();

  void post(T? value, {bool force = false}) {
    if (!force && value == this.value) return;
    publishSubject.add(_value = value);
  }

  Stream<T?> stream() => publishSubject.stream;
  StreamSubscription<T?> listen(void Function(T? event) onData,
          {Function? onError, void Function()? onDone, bool? cancelOnError}) =>
      publishSubject.stream.listen(onData,
          onError: onError, onDone: onDone, cancelOnError: cancelOnError);
  bool get hasListeners => publishSubject.hasListener;

  void close() => publishSubject.close();

  @override
  int get hashCode => id?.hashCode ?? super.hashCode;

  @override
  bool operator ==(other) {
    if (other is! AdeptPublishSubject<T>) return false;
    if (id != null && other.id != null) return id == other.id;
    return value == other.value;
  }
}
